package com.example.GPSCam;

import java.io.File;
import com.example.GPSCam.R;
import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.location.GpsStatus;
import android.location.Location;
import android.location.LocationListener;
import android.location.LocationManager;
import android.net.Uri;
import android.os.Bundle;
import android.provider.MediaStore;
import android.text.InputType;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.ViewGroup.LayoutParams;
import android.webkit.WebView;
import android.widget.EditText;
import android.widget.Toast;

public class GPSCam extends Activity implements LocationListener,
		GpsStatus.Listener {

	private LocationManager locationManager;
	WebView position;

	public static final int OUT_OF_SERVICE = 0;
	public static final int TEMPORARILY_UNAVAILABLE = 1;
	public static final int AVAILABLE = 2;

	public static final int ADD_DESCRIPTION = 1;
	public static final int EXITAPP = 2;

	private static final int CAPTURE_IMAGE_ACTIVITY_REQUEST_CODE = 100;

	private int GPSValid = 1;
	private boolean GPSEnabled = true;
	// variables for gps lat,long, and their references "N/S/E/W"
	private String latDegree, latMin, latSec, sLatR, lngDegree, lngMin, lngSec,
			sLngR;

	private Intent camIntent;
	String photoFile;
	Uri outputFileUri;

	private double testLat = 1.3104211678728461;
	private double testLng = 103.90087947249413;

	boolean stopLocUpdate = false;
	ImageObject io = new ImageObject();
	DBObject dbo;

	/** Called when the activity is first created. */
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_gpscam);
		dbo = new DBObject(this);
		this.io.setLat(-1);
		this.io.setLng(-1);
		// ///position = (WebView) findViewById(R.id.WebView);
		// ///position.getSettings().setJavaScriptEnabled(true);

		// define locationManager, in this case, the service we are interested
		// in is location service
		locationManager = (LocationManager) getSystemService(Context.LOCATION_SERVICE);

		// this line defines how frequent to update, 2nd parameter is the
		// frequency in time to update, 3rd parameter is frequency in distance
		// to update, 4th parameter is the listener
		locationManager.requestLocationUpdates(locationManager.GPS_PROVIDER, 0,
				0, this);
		GPSEnabled = this.checkGPSEnable(getApplicationContext(),
				locationManager);

		locationManager.addGpsStatusListener(this);

		this.startCamera();
	}

	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		// super.onCreateOptionsMenu(menu);

		// this.camIntent.addCategory(Intent.CATEGORY_ALTERNATIVE);

		// menu.addIntentOptions(R.id.menu_settings, 0, 0,
		// this.getComponentName(), null, this.camIntent, 0, null);
		menu.add(1, ADD_DESCRIPTION, 1, "Add Description").setIntent(
				new Intent(MediaStore.INTENT_ACTION_STILL_IMAGE_CAMERA));
		// menu.add(0, EXITAPP, 2, "Exit").setIntent(camIntent);
		return super.onCreateOptionsMenu(menu);
	}

	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		switch (item.getItemId()) {
		case ADD_DESCRIPTION:
			Log.d("menu but", "you clicked on item " + item.getTitle());
			return true;
		case 0:
			Log.d("menu but", "you clicked on item " + item.getTitle());
			return true;
		case 2:
			Log.d("menu but", "you clicked on item " + item.getTitle());
			return true;
			// case EXITAPP:
			// Log.d("menu but", "you clicked on item " + item.getTitle());
			// return true;
		}
		return super.onOptionsItemSelected(item);

	}

	public void onDestroy() {
		// finish();
		super.onDestroy();
	}

	protected void startCamera() {
		// get the picture file to manipuate
		this.io.setPath(this.io.setUpImageFile(this.getApplicationContext(),
				GPSValid, this.io));

		// obtain uri
		Uri outputFileUri = Uri.fromFile(this.io.getPath());
		Log.d("globpicfile in startcam", "globpicfile: "
				+ this.io.getPath().getPath());
		// create camera intent
		camIntent = new Intent(MediaStore.ACTION_IMAGE_CAPTURE);
		// define where to keep the photo
		camIntent.putExtra(MediaStore.EXTRA_OUTPUT, outputFileUri);

		// this method will call onActivityResult() upon finishing an activity
		// i.e. image captured
		startActivityForResult(camIntent, CAPTURE_IMAGE_ACTIVITY_REQUEST_CODE);
	}

	// this method is called upon completing an activity, here, take photo
	protected void onActivityResult(int requestCode, int resultCode, Intent data) {
		if (requestCode == CAPTURE_IMAGE_ACTIVITY_REQUEST_CODE) {
			if (resultCode == RESULT_OK) {
				// updatePictureFile is used to move the file if GPS signal is
				// valid
				File updatePictureFile = null;

				Log.d("onactivityresult", "activity result  "
						+ this.io.getPath().toString());

				Toast.makeText(this, "Picture saved.", Toast.LENGTH_SHORT)
						.show();

				if (GPSValid == 0) {
					// if GPS is valid, calculate the distance from source to
					// dest to bound a radius
					this.io.setPath(this.io.setUpImageFile(
							this.getApplicationContext(), GPSValid, this.io));
					stopLocUpdate = true;

					if (this.calculateGPSDistance() < 10) {
						Toast.makeText(this, "at home", Toast.LENGTH_SHORT)
								.show();
						Log.d("distance", "at home");
					} else {
						Toast.makeText(this, "NOT at home", Toast.LENGTH_SHORT)
								.show();
						Log.d("distance", "NOT at home");
					}

					Toast.makeText(this,
							"Distance is: " + this.calculateGPSDistance(),
							Toast.LENGTH_SHORT).show();
					Log.d("distance", "" + this.calculateGPSDistance()
							+ "t/f: " + (this.calculateGPSDistance() < 10));

					Log.d("globPicturefile path", this.io.getPath().getPath());
					updatePictureFile = new File(this.io.setUpImageFile(
							this.getApplicationContext(), GPSValid, this.io)
							.getPath());

					Log.d("updatePictureFile in activityresult", ""
							+ updatePictureFile.getPath());

					this.io.getPath().renameTo(updatePictureFile);

					this.io.triggerMediaScanner(this.io.getPath(), this);
					this.io.triggerMediaScanner(updatePictureFile, this);
				} else if (GPSValid == 1) {
					this.io.setPath(this.io.setUpImageFile(
							this.getApplicationContext(), GPSValid, this.io));
					updatePictureFile = this.io.getPath();
					this.io.triggerMediaScanner(this.io.getPath(), this);
					this.io.triggerMediaScanner(updatePictureFile, this);
				}
				// Log.d("distance", "" + distance[0]);
				Log.d("updatPicFile name", updatePictureFile.toString());
				// process the GPS coord
				this.processCoord(this.io.getLat(), this.io.getLng());
				// save information to EXIF
				Log.d("error check after process coord",
						"error check after process corrd");
				this.io.saveToEXIF(updatePictureFile, latDegree, lngDegree,
						latMin, lngMin, latSec, lngSec, sLatR, sLngR);
				Log.d("error check after eXIF", "error check after EXITF");
				// trigger media scanner
				// this.triggerMediaScanner(updatePictureFile);
				
				Log.d("inserting", "insertig path = " + this.io.getPath());
				dbo.addImage(new ImageObject(this.io.getPath(), this.io
						.getLat(), this.io.getLng(), this.io.getDescription()));
				Log.d("done inserting", "done insertig");
				
				Log.d("image count", "count = " + dbo.getImageCount());
				
				Log.d("retriving", "retriving paht = "
						+ this.io.getPath().getPath());
				ImageObject dbImage = dbo.getImageInfo(this.io.getPath()
						.getPath());

				Log.d("db info",
						"path = " + dbImage.getPath().getPath() + " lat = "
								+ dbImage.getLat() + " lng = "
								+ dbImage.getLng() + " desc = "
								+ dbImage.getDescription());
				finish();
			} else if (resultCode == RESULT_CANCELED) {
				Toast.makeText(this, "Picture was not taken",
						Toast.LENGTH_SHORT).show();
			} else {
				Toast.makeText(this, "Picture was not taken",
						Toast.LENGTH_SHORT).show();
			}
			// upon finish current activity, allow user to take another picture
			EditText ed = new EditText(this);
			ed.setInputType(InputType.TYPE_CLASS_TEXT);
			ed.setLayoutParams(new LayoutParams(LayoutParams.MATCH_PARENT,
					LayoutParams.MATCH_PARENT));

			finish();
			startActivity(new Intent(GPSCam.this, this.getClass()));

		}
	}

	public boolean checkGPSEnable(Context context,
			LocationManager locationManager) {
		boolean enabledGPS = locationManager
				.isProviderEnabled(LocationManager.GPS_PROVIDER);

		if (!enabledGPS) {
			Toast.makeText(getApplicationContext(), "GPS is not enabled",
					Toast.LENGTH_SHORT).show();
			GPSValid = 1;
			return false;
		} else {
			GPSValid = 0;
			return true;
		}
	}

	// convert coord to DMS format and get reference for EXIF
	protected void processCoord(double coordLat, double coordLng) {
		// get the decimal portion of coord
		double deciNum = coordLat % 1;
		// get the whole number part
		int wholeNum = (int) coordLat;

		// process latitude to dms
		// define latDegree
		latDegree = String.valueOf(wholeNum);

		// for minute, we want the decimal portion of coord * 60
		coordLat = deciNum * 60;
		// get the decimal portion
		deciNum = coordLat % 1;
		// get the whole number part
		wholeNum = (int) coordLat;

		// define latMin
		latMin = String.valueOf(wholeNum);

		// for seconds, we want the decimal portion of the minutes *60
		coordLat = deciNum * 60;
		// get the whole number portion of it
		wholeNum = (int) coordLat;

		// define latSec
		latSec = String.valueOf(wholeNum);
		// end lat deci to dms

		// process long to dms
		deciNum = coordLng % 1;
		wholeNum = (int) coordLng;

		lngDegree = String.valueOf(wholeNum);

		coordLng = deciNum * 60;
		deciNum = coordLng % 1;
		wholeNum = (int) coordLng;

		lngMin = String.valueOf(wholeNum);

		coordLng = deciNum * 60;
		wholeNum = (int) coordLng;

		lngSec = String.valueOf(wholeNum);
		// end long deci to dms

		if (coordLat < 0) {
			sLatR = "S";
		} else {
			sLatR = "N";
		}

		if (coordLng < 0) {
			sLngR = "W";
		} else {
			sLngR = "E";
		}
	}

	// this method obtains the distance between 2 locations from GPS
	protected float calculateGPSDistance() {
		// create the source location
		Location source = new Location("source");
		// set the lat and lng of the source, now hard coded
		source.setLatitude(this.testLat);
		source.setLongitude(this.testLng);
		// actual

		// create the destination location
		Location dest = new Location("dest");
		dest.setLatitude(this.io.getLat());
		dest.setLongitude(this.io.getLng());

		Log.d("dist values", "slat: " + source.getLatitude() + " slng: "
				+ source.getLongitude() + " dlat: " + dest.getLatitude()
				+ " dlng: " + dest.getLongitude());

		// obtain the distance from souce to destination in meters and return
		// the value
		return source.distanceTo(dest);
	}

	public void onGpsStatusChanged(int event) {
		switch (event) {
		case GpsStatus.GPS_EVENT_STARTED:
			// Started
			break;
		case GpsStatus.GPS_EVENT_FIRST_FIX:
			// First Fix
			GPSValid = 0;
			Toast.makeText(getApplicationContext(),
					"Check GPS Valid listener ff: " + GPSValid,
					Toast.LENGTH_SHORT).show();
			Log.d("Check GPS Valid listener: ff", "awdwa: " + GPSValid);
			break;
		case GpsStatus.GPS_EVENT_STOPPED:
			// Stopped
			GPSValid = 1;
			Toast.makeText(getApplicationContext(),
					"Check GPS Valid listener: stop" + GPSValid,
					Toast.LENGTH_SHORT).show();
			Log.d("Check GPS Valid listener: stop", "awdwa: " + GPSValid);
			break;
		}
	}

	/*
	 * LocationListener implements 4 methods, 1)onLocationChanged,
	 * 2)onStatusChanged, 3)onProviderEnabled ,4)onProviderDisabled This method
	 * defines the operation to be performed when a location is changed
	 */
	public void onLocationChanged(Location location) {
		if (this.stopLocUpdate == false) {
			this.io.setLat(location.getLatitude());
			this.io.setLng(location.getLongitude());
			String text = "My location is: Lat = " + this.io.getLat()
					+ " Lgn = " + this.io.getLng() + " GPSValid is: "
					+ GPSValid;
			Log.d("GPS DATA", text);
			// Toast.makeText(getApplicationContext(), text, Toast.LENGTH_SHORT)
			// .show();

			// this is the url to display the current location on google map
			/*
			 * String url = "http://maps.google.com/staticmap?center=" + lat +
			 * "," + lng + "&zoom=18&size=512x512&maptype=mobile/&markers=" +
			 * lat + "," + lng;
			 */
			// load the URL
			// ///position.loadUrl(url);
		}
	}

	// This method is called when status of service provider is changed such as
	// temporary unavailable to available
	public void onStatusChanged(String provider, int status, Bundle extras) {
		// TODO Auto-generated method stub
	}

	// This method is called when service provider is enabled
	public void onProviderEnabled(String provider) {
		/*
		 * Toast.makeText(this, "Enabled new provider " + provider,
		 * Toast.LENGTH_SHORT).show();
		 */
	}

	// This method is called when service provider is disabled
	public void onProviderDisabled(String provider) {
		/*
		 * Toast.makeText(this, "Disabled provider " + provider,
		 * Toast.LENGTH_SHORT).show();
		 */
	}
}
